//
//  ListProductsViewController.swift
//  shuup
//
//  Created by Yeison Vargas on 3/15/19.
//  Copyright (c) 2019 Rokk3rlabs. All rights reserved.
//
//  This file was generated by the Clean Swift Xcode Templates so
//  you can apply clean architecture to your iOS and Mac projects,
//  see http://clean-swift.com
//

import UIKit

protocol ListProductsDisplayLogic: class
{
  func displayProducts(viewModel: ListProducts.FetchProducts.ViewModel)
  func displayStockUpdate(viewModel: ListProducts.UpdateStock.ViewModel)
  func refreshCartData(refreshedCart: [Int: ShoopingCart.ViewModel.DisplayedProductInCart]?)
}

class ProductTableViewCell: UITableViewCell {
    @IBOutlet weak var name: UILabel!
    @IBOutlet weak var price: UILabel!
    @IBOutlet weak var stock: UILabel!
    @IBOutlet weak var buy: UIButton!
}

class ListProductsViewController: UIViewController, UITableViewDelegate, UITableViewDataSource, ListProductsDisplayLogic
{
  var interactor: ListProductsBusinessLogic?
  var router: (NSObjectProtocol & ListProductsRoutingLogic & ListProductsDataPassing)?
  var displayedProducts: [ListProducts.FetchProducts.ViewModel.DisplayedProduct] = []
  var cacheProducts: [ListProducts.FetchProducts.ViewModel.DisplayedProduct] = []
  var cartVC: CartViewController? = nil


    var displayedCart: [Int: ShoopingCart.ViewModel.DisplayedProductInCart] = [:]

    @IBOutlet weak var productsTableView: UITableView!

    @IBOutlet weak var totalLabel: UILabel!
    @IBOutlet weak var counterLabel: UILabel!
    // MARK: Object lifecycle
  
  override init(nibName nibNameOrNil: String?, bundle nibBundleOrNil: Bundle?)
  {
    super.init(nibName: nibNameOrNil, bundle: nibBundleOrNil)
    setup()
  }
  
  required init?(coder aDecoder: NSCoder)
  {
    super.init(coder: aDecoder)
    setup()
  }
  
  // MARK: Setup
  
  private func setup()
  {
    let viewController = self
    let interactor = ListProductsInteractor()
    let presenter = ListProductsPresenter()
    let router = ListProductsRouter()
    viewController.interactor = interactor
    viewController.router = router
    interactor.presenter = presenter
    presenter.viewController = viewController
    router.viewController = viewController
    router.dataStore = interactor

    let sb = UIStoryboard(name: "Cart", bundle: nil)
    self.cartVC = (sb.instantiateViewController(withIdentifier: "CartViewController")
        as! CartViewController)

    // Share instances
    self.cartVC!.interactor = interactor
    self.cartVC!.productsViewController = self
  }
  
  // MARK: Routing
  
  override func prepare(for segue: UIStoryboardSegue, sender: Any?)
  {
    if let scene = segue.identifier {
      let selector = NSSelectorFromString("routeTo\(scene)WithSegue:")
      if let router = router, router.responds(to: selector) {
        router.perform(selector, with: segue)
      }
    }
  }
  
  // MARK: View lifecycle
  
  override func viewDidLoad()
  {
    super.viewDidLoad()
    loadProducts()
  }
  
  // MARK: Do something
  
  //@IBOutlet weak var nameTextField: UITextField!
  
  func loadProducts()
  {
    let request = ListProducts.FetchProducts.Request()
    interactor?.fetchProducts(request: request)
  }
  
  func displayProducts(viewModel: ListProducts.FetchProducts.ViewModel)
  {
    displayedProducts = viewModel.displayedProducts
    cacheProducts = viewModel.displayedProducts
    productsTableView.reloadData()
  }

    func displayStockUpdate(viewModel: ListProducts.UpdateStock.ViewModel) {
        var index = displayedProducts.firstIndex(where: { $0.id == viewModel.displayedStockUpdate.id })

        if viewModel.displayedStockUpdate.removeFromSale {
            displayedProducts.remove(at: index!)
        } else {

            // Insert again from CACHE
            if index == nil {
                index = cacheProducts.firstIndex(where: { $0.id == viewModel.displayedStockUpdate.id })
                displayedProducts.insert(cacheProducts[index!], at: index!)
            }

            displayedProducts[index!].stock = viewModel.displayedStockUpdate.stock
        }
        cartVC!.products = displayedProducts

        productsTableView.reloadData()
    }

    func refreshCartData(refreshedCart: [Int: ShoopingCart.ViewModel.DisplayedProductInCart]?) {
        if let updatedCart = refreshedCart {
            displayedCart = updatedCart
        }

        var counter = 0
        var total = 0.0
        for itemType in displayedCart.values {
            counter += itemType.quantity
            total += Double(itemType.quantity) * Double(cacheProducts.first { $0.id == itemType.id }!.price)!
        }

        counterLabel.text = String(counter)
        totalLabel.text = String(total) + " USD"
    }

    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return displayedProducts.count
    }

    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell: ProductTableViewCell = {
            guard let cell = tableView.dequeueReusableCell(withIdentifier: "ProductTableViewCell") else {
                return UITableViewCell(style: .default, reuseIdentifier: "ProductTableViewCell")
                    as! ProductTableViewCell
            }
            return cell as! ProductTableViewCell
        }()

        cell.name.text = displayedProducts[indexPath.row].name
        cell.price.text = displayedProducts[indexPath.row].price
        cell.buy.tag = displayedProducts[indexPath.row].id

        cell.buy.addTarget(self, action: #selector(self.handleTap(_:)), for: .touchUpInside)
        
        cell.stock.text = displayedProducts[indexPath.row].stock

        return cell
    }


    @objc func handleTap(_ sender: UIButton) {
        let productId = sender.tag
        print("TAG")
        print(productId)

        let selectedProduct = displayedProducts.first(where: { $0.id == productId })!

        interactor?.updateStock(request: ListProducts.UpdateStock.Request(remove: true,
                                                                          product: selectedProduct))
        var quantity = 1

        if let prodInCart = displayedCart[productId] {
            quantity = prodInCart.quantity + 1
        }

        displayedCart[productId] = ShoopingCart.ViewModel.DisplayedProductInCart(id: selectedProduct.id,
                                                                                 name: selectedProduct.name,
                                                                                 quantity: quantity)
        refreshCartData(refreshedCart: nil)
    }

    @IBAction func handleCounterTap(_ sender: Any) {

        cartVC!.cart = displayedCart
        cartVC!.products = displayedProducts
        cartVC!.cacheProducts = cacheProducts

        UIView.animate(withDuration: 0.4, delay: 0, options: [], animations: {
            self.counterLabel.shake(duration: 0.1, repeatCount: 2)
        }, completion: { _ in
            self.present(self.cartVC!, animated: true)
        })

    }


}

// Move this to another file

extension UIView {

    func shake(duration: Double, repeatCount: Float) {

        let shake = CABasicAnimation(keyPath: "position")
        shake.duration = duration
        shake.repeatCount = repeatCount
        shake.autoreverses = true

        let fromPoint = CGPoint(x: center.x - 5, y: center.y)
        let fromValue = NSValue(cgPoint: fromPoint)

        let toPoint = CGPoint(x: center.x + 5, y: center.y)
        let toValue = NSValue(cgPoint: toPoint)

        shake.fromValue = fromValue
        shake.toValue = toValue

        layer.add(shake, forKey: "position")
    }
}
